%global debug_package %{nil}

Name:           v2ray
Version:        5.33.0
Release:        1%{?dist}
Summary:        A platform for building proxies to bypass network restrictions.
License:        MIT
URL:            https://github.com/v2fly/v2ray-core
Packager:       Teddysun <i@teddysun.com>

Source0:        https://github.com/v2fly/v2ray-core/archive/refs/tags/v%{version}.tar.gz#/v2ray-core-%{version}.tar.gz
Source1:        config.json
Source2:        https://github.com/v2fly/geoip/releases/latest/download/geoip.dat
Source3:        https://github.com/v2fly/geoip/releases/latest/download/geoip-only-cn-private.dat
Source4:        https://github.com/v2fly/domain-list-community/releases/latest/download/dlc.dat

#BuildRequires:  golang >= 1.22
%if 0%{?rhel} && 0%{?rhel} < 8
BuildRequires:  systemd
%else
BuildRequires:  systemd-rpm-macros
%endif
%{?systemd_requires}
Provides:       Productivity/Networking/Web/Proxy

%description
A platform for building proxies to bypass network restrictions.

%prep
%setup -q -n v2ray-core-%{version}

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags

LDFLAGS='-s -w -buildid='
env CGO_ENABLED=0 go build -v -trimpath -ldflags "$LDFLAGS" -o %{name} ./main

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 %{name} %{buildroot}%{_bindir}

%{__install} -d %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{S:1} %{buildroot}%{_sysconfdir}/%{name}/config.json

%{__install} -d %{buildroot}%{_datadir}/%{name}
%{__install} -p -m 0644 %{S:2} %{buildroot}%{_datadir}/%{name}/geoip.dat
%{__install} -p -m 0644 %{S:3} %{buildroot}%{_datadir}/%{name}/geoip-only-cn-private.dat
%{__install} -p -m 0644 %{S:4} %{buildroot}%{_datadir}/%{name}/geosite.dat

%{__install} -d %{buildroot}%{_unitdir}
cat > %{buildroot}%{_unitdir}/%{name}.service <<EOF
[Unit]
Description=V2Rray Service
Documentation=https://github.com/v2fly/v2ray-core
After=network.target nss-lookup.target

[Service]
CapabilityBoundingSet=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
NoNewPrivileges=true
ExecStart=/usr/bin/v2ray run -config /etc/v2ray/config.json
Restart=on-failure
RestartPreventExitStatus=23
LimitNPROC=10000
LimitNOFILE=1000000

[Install]
WantedBy=multi-user.target
EOF
cat > %{buildroot}%{_unitdir}/%{name}@.service <<EOF
[Unit]
Description=V2Rray Service
Documentation=https://github.com/v2fly/v2ray-core
After=network.target nss-lookup.target

[Service]
CapabilityBoundingSet=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
NoNewPrivileges=true
ExecStart=/usr/bin/v2ray run -config /etc/v2ray/%i.json
Restart=on-failure
RestartPreventExitStatus=23
LimitNPROC=10000
LimitNOFILE=1000000

[Install]
WantedBy=multi-user.target
EOF

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%{_bindir}/%{name}
%{_unitdir}/%{name}.service
%{_unitdir}/%{name}@.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/config.json
%{_datadir}/%{name}/*.dat
%license LICENSE
%doc README.md

%changelog
* Tue May 27 2025 Teddysun <i@teddysun.com> - 5.33.0-1
- Update to version 5.33.0

* Sun May 18 2025 Teddysun <i@teddysun.com> - 5.32.0-1
- Update to version 5.32.0

* Tue Apr 29 2025 Teddysun <i@teddysun.com> - 5.31.0-1
- Update to version 5.31.0

* Mon Apr 07 2025 Teddysun <i@teddysun.com> - 5.30.0-1
- Update to version 5.30.0

* Mon Mar 24 2025 Teddysun <i@teddysun.com> - 5.29.3-1
- Update to version 5.29.3

* Fri Feb 28 2025 Teddysun <i@teddysun.com> - 5.29.2-1
- Update to version 5.29.2

* Fri Feb 21 2025 Teddysun <i@teddysun.com> - 5.29.1-1
- Update to version 5.29.1

* Mon Feb 17 2025 Teddysun <i@teddysun.com> - 5.29.0-1
- Update to version 5.29.0

* Tue Feb 11 2025 Teddysun <i@teddysun.com> - 5.28.0-1
- Update to version 5.28.0

* Fri Feb 07 2025 Teddysun <i@teddysun.com> - 5.27.0-1
- Update to version 5.27.0

* Mon Jan 27 2025 Teddysun <i@teddysun.com> - 5.26.0-1
- Update to version 5.26.0

* Wed Jan 22 2025 Teddysun <i@teddysun.com> - 5.25.1-1
- Update to version 5.25.1

* Sat Jan 18 2025 Teddysun <i@teddysun.com> - 5.25.0-1
- Update to version 5.25.0

* Thu Jan 09 2025 Teddysun <i@teddysun.com> - 5.24.0-1
- Update to version 5.24.0

* Tue Dec 10 2024 Teddysun <i@teddysun.com> - 5.23.0-1
- Update to version 5.23.0

* Mon Oct 28 2024 Teddysun <i@teddysun.com> - 5.22.0-1
- Update to version 5.22.0

* Sun Oct 13 2024 Teddysun <i@teddysun.com> - 5.21.0-1
- Update to version 5.21.0

* Wed Oct 02 2024 Teddysun <i@teddysun.com> - 5.20.0-1
- Update to version 5.20.0

* Mon Sep 16 2024 Teddysun <i@teddysun.com> - 5.19.0-1
- Update to version 5.19.0

* Mon Sep 09 2024 Teddysun <i@teddysun.com> - 5.18.0-1
- Update to version 5.18.0

* Sun Aug 25 2024 Teddysun <i@teddysun.com> - 5.17.1-1
- Update to version 5.17.1

* Sat Aug 24 2024 Teddysun <i@teddysun.com> - 5.17.0-1
- Update to version 5.17.0

* Fri May 03 2024 Teddysun <i@teddysun.com> - 5.16.1-1
- Update to version 5.16.1

* Fri Apr 19 2024 Teddysun <i@teddysun.com> - 5.15.3-1
- Update to version 5.15.3

* Sun Mar 17 2024 Teddysun <i@teddysun.com> - 5.15.1-1
- Update to version 5.15.1

* Tue Mar 05 2024 Teddysun <i@teddysun.com> - 5.14.1-1
- Update to version 5.14.1

* Tue Dec 12 2023 Teddysun <i@teddysun.com> - 5.13.0-1
- Update to version 5.13.0

* Fri Nov 24 2023 Teddysun <i@teddysun.com> - 5.12.1-1
- Update to version 5.12.1

* Mon Nov 20 2023 Teddysun <i@teddysun.com> - 5.12.0-1
- Update to version 5.12.0

* Sat Nov 04 2023 Teddysun <i@teddysun.com> - 5.11.0-1
- Update to version 5.11.0

* Sat Oct 28 2023 Teddysun <i@teddysun.com> - 5.10.0-1
- Update to version 5.10.0

* Wed Oct 25 2023 Teddysun <i@teddysun.com> - 5.9.0-1
- Update to version 5.9.0

* Wed Oct 18 2023 Teddysun <i@teddysun.com> - 5.8.0-1
- Update to version 5.8.0
